﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.system.singleton;

// 
// スレッド内で1つのクラス
// 

private import std.thread;

class ThreadSingleton(T: Object)
{
protected:
	T[uint]	m_singleton;
	
public:
	T get()
	{
		uint id = Thread.getThis.id;
		
		synchronized {
			if ((id in m_singleton) == null) {
				m_singleton[id] = new T;
			}
		}
		
		return m_singleton[id];
	}
}

